/*****************************************************************
 *                        PINOCCHIO  V4.1                        *
 *  (PINpointing Orbit-Crossing Collapsed HIerarchical Objects)  *
 *****************************************************************
 
 This code was written by
 Pierluigi Monaco
 Copyright (C) 2016
 
 web page: http://adlibitum.oats.inaf.it/monaco/pinocchio.html
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "pinocchio.h"

int ThisTask,NTasks;

void *main_memory, *wheretoplace_mycat;
product_data *products, *frag;
unsigned int **seedtable;
double **kdensity;
double **density;
double ***first_derivatives;
double ***second_derivatives;
double **VEL_for_displ;

#ifdef TWO_LPT
double *kvector_2LPT;
double *source_2LPT;
double **VEL2_for_displ;
#ifdef THREE_LPT
double *kvector_3LPT_1,*kvector_3LPT_2;
double *source_3LPT_1,*source_3LPT_2;
#endif
#endif

double Rsmooth;
smoothing_data Smoothing;

grid_data *MyGrids;
int Ngrids;

fftw_complex **cvector_fft;
double **rvector_fft;

param_data params={0};
output_data outputs;
subbox_data subbox;
#ifdef PLC
plc_data plc;
plcgroup_data *plcgroups;
#endif

cputime_data cputime={0.0};

int WindowFunctionType;

group_data *groups;

char date_string[25];

int *indices,*group_ID,*linking_list;
double f_m, f_rm, espo, f_a, f_ra, f_200, sigmaD0;
int NSlices,ThisSlice;

#ifdef SCALE_DEPENDENT_GROWTH
SDGM_data SDGM;
#endif

gsl_integration_workspace * workspace;
gsl_rng *random_generator;

mf_data mf;

